package io.zipcoder.casino;

public class Player {

    private double playerBalance;
    private Wallet wallet;
    private String playerName = "Chaitali";
    //private Hand hand;
    private int numCards;

    private Card[] hand = new Card[10];

    public Card[] getHand() {
        return hand;
    }

    public Player(String aName) {
        this.playerName = aName;
        this.emptyHand();
    }

    public void emptyHand(){
        for (int c= 0; c<10; c++){
            this.hand[c] = null;
        }
        this.numCards=0;
    }

    public boolean addCard(Card aCard){
        if (this.numCards == 10) {
            System.err.printf("%s's hand already has 10 cards;" + "cannot add another\n", this.playerName);
            System.exit(1);
        }
        this.hand[this.numCards] = aCard;
        this.numCards++;

        return(this.getHandSum() <= 21);

    }

    public int getHandSum(){
        int handSum = 0;
        int cardNum;
        int numAces = 0;

        for (int i= 0; i<this.numCards; i++){
            cardNum = this.hand[i].getNumber();

            if(cardNum == 1 ){
                numAces++;
                handSum += 11;
            } else if (cardNum > 10){
                handSum += 10;
            } else {
                handSum += cardNum;
            }
        }

        while(handSum > 21 && numAces > 0){
            handSum -= 10;
            numAces--;
        }

        return handSum;
    }

    public void printHand(boolean showFirstCard){
        System.out.printf("%s's cards:\n", this.playerName);
        for (int c= 0; c<this.numCards; c++) {
            if (c == 0 && !showFirstCard) {
                System.out.println(" [hidden] ");
            } else {
                System.out.printf(" %s\n", this.hand[c].toString());
            }
        }
    }

}

