package io.zipcoder.casino.java;

import io.zipcoder.casino.Card;
import io.zipcoder.casino.Hand;
import io.zipcoder.casino.Rank;
import io.zipcoder.casino.Suits;
import org.junit.Assert;
import org.junit.Test;

public class HandTest {
    Hand hand = new Hand();

    @Test
    public void testGetTotalHandValue_forRegularNumber()
    {
        //Given
        hand.addCard(new Card(Suits.HEART, Rank.TWO));
        hand.addCard(new Card(Suits.HEART, Rank.EIGHT));
        hand.addCard(new Card(Suits.HEART, Rank.FIVE));
        int expected = 15;

        //When
        int actualValue = hand.getTotalHandValue();

        //Then
        Assert.assertEquals(expected, actualValue);
    }

    @Test
    public void testGetTotalHandValue_forFaces()
    {
        //Given
        hand.addCard(new Card(Suits.HEART, Rank.JACK));
        hand.addCard(new Card(Suits.HEART, Rank.QUEEN));
        int expected = 20;

        //When
        int actualValue = hand.getTotalHandValue();

        //Then
        Assert.assertEquals(expected, actualValue);
    }

    @Test
    public void testGetTotalHandValue_forAces() {
       //Given
        hand.addCard(new Card(Suits.HEART, Rank.ACE));
        hand.addCard(new Card(Suits.HEART, Rank.ACE));
        hand.addCard(new Card(Suits.HEART, Rank.FIVE));
        int expected = 17;

        //When
        int actualValue = hand.getTotalHandValue();

        //Then
        Assert.assertEquals(expected, actualValue);
    }


    @Test
    public void testGetNumberOfCards() {
        //Given
        hand.addCard(new Card(Suits.HEART, Rank.ACE));
        hand.addCard(new Card(Suits.HEART, Rank.ACE));
        int expected = 2;

        //When
        int actualValue = hand.getNumberOfCards();

        //Then
        Assert.assertEquals(expected, actualValue);
    }
    @Test
    public void testIsHandEmpty() {
        //Given
        Hand hand = new Hand();

        //When
        Boolean actual = hand.isHandEmpty();

        //Then
        Assert.assertNotNull(actual);
    }

}
